/*
 * Copyright 2014 Nicolas Morel
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.github.nmorel.gwtjackson.client.mapper;

import com.github.nmorel.gwtjackson.client.GwtJacksonTestCase;
import com.github.nmorel.gwtjackson.client.JsonDeserializationContext.Builder;
import com.github.nmorel.gwtjackson.client.ObjectMapper;
import com.github.nmorel.gwtjackson.shared.ObjectMapperTester;
import com.github.nmorel.gwtjackson.shared.mapper.IgnoreStaticTester;
import com.github.nmorel.gwtjackson.shared.mapper.IgnoreStaticTester.IgnoreStaticBean;
import com.github.nmorel.gwtjackson.shared.mapper.PropertyNamingTester;
import com.github.nmorel.gwtjackson.shared.mapper.PropertyNamingTester.PropertyNamingBean;
import com.google.gwt.core.client.GWT;

/**
 * @author Nicolas Morel
 */
public class PropertyNamingGwtTest extends GwtJacksonTestCase {

    public interface PropertyNamingBeanMapper extends ObjectMapper<PropertyNamingBean>, ObjectMapperTester<PropertyNamingBean> {

        static PropertyNamingBeanMapper INSTANCE = GWT.create( PropertyNamingBeanMapper.class );
    }

    public void testValue() {
        PropertyNamingTester.INSTANCE.testValue( createMapper( PropertyNamingBeanMapper.INSTANCE ) );
    }
}
